#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

print "Content-type: text/html\n\n";


for ($ms = 0; $ms < $q->param('inumber'); $ms++)
	{
	$cbox_name = "C" . $ms;
	if ($q->param($cbox_name) ne "")
		{
		$current_id = $q->param($cbox_name);
		$sql_del = $sql_del . " lnkid = '$current_id' or";
		}
	}
$sql_del = substr($sql_del, 0, length($sql_del) - 2);

if ($sql_del eq "")
	{
	acs::problem_popup("You have to select something."); exit;
	}


### CONNECT TO DB

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

#print "DELETE FROM brokenlnks WHERE $sql_del <br>";

if ($q->param('fct') eq "lchecker")
{
$sql = "DELETE FROM brokenlnks2 WHERE $sql_del";
}
else
{
$sql = "DELETE FROM brokenlnks WHERE $sql_del";
}

$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 

if (($q->param('B3') ne "") and ($q->param('daction1') eq "delete"))
	{
	#$sql = "DELETE FROM links WHERE $sql_del";
	#$sth = $dbh->prepare($sql);
	#$sth->execute;
	#$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
	
	&delete_listings;
	$del_action = "Links Deleted";
	}
	elsif  (($q->param('B4') ne "") and ($q->param('daction') eq "delete"))
	{
	&delete_listings;
	$del_action = "Links Deleted";
	}
	else
	{
	$del_action = "Links Removed From Que";
	}

$sth->finish;
$dbh->disconnect;


$fct = $q->param('fct');


$hbox = acs::get_heading_box("$web_url/ic_dirs.gif", "$del_action", qq[
<a href="$admin_url/admin58.cgi?fct=$fct">Click here to continue</a>
]);
 


print <<END_OF_FINISH;

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>

END_OF_FINISH

####################################################################################


sub delete_listings
{

### GET ALL CATEGORIES TO PREPARE LINK NUMBER UPDATE

$links_to_move = $q->param('links');
@all_links = split(/-/, $links_to_move);


for ($ms = 0; $ms < $q->param('inumber'); $ms++)
	{
	$cbox_name = "C" . $ms;
	if ($q->param($cbox_name) ne "")
		{
		$current_id = $q->param($cbox_name);
		$all_links[$ms] = $current_id;
		}
	}


$lnknumber = @all_links;

foreach $item (@all_links)
	{
	$sql_str = $sql_str . "(B.lnkid = '$item') OR ";
	}
	
$sql_str = substr($sql_str, 0, length($sql_str) - 3);

### GET CATEGORY NAMES TO UPDATE CATEGORY NUMBERS

$sql = "SELECT A.cid, A.l1, A.l2, A.l3, A.l4, A.l5, A.l6, A.l7, A.l8, A.l9, A.l10, A.l11, A.l12, A.l13, A.l14, A.l15, A.l16,
					B.lnkid 
					FROM dirs AS A, links AS B WHERE ($sql_str) AND (A.cid = B.cid)";

$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}

$nrcounter = 0;
while ( @row = $sth->fetchrow() )
	{
		
		$cats = "";
		for ($ms = 1; $ms < 17; $ms++) 
				{
				if ($row[$ms] ne "")
					{
					$cats = $cats . $row[$ms] . "::-::";
					}
				} 
		$cats = substr($cats, 0, length($cats) - 5);
			
	$move_crit[$nrcounter] = $row[17] . "--oo--" . $cats;
	$nrcounter++;
	
	} 


### UPDATE LINK NUMBERS IN CATEGORIES

$gcntr = 0;
foreach $item (@move_crit)
	{
	#print $item . "<BR>";
	
	($the_lnkid, $thecat) = split (/--oo--/, $item);
	
		my @allcats = split (/::-::/, $thecat);
			
			$cnc = 1; $sqlcrit = "";
			foreach $catitem (@allcats)
				{
				$catitem =~ s/'/\\'/g;  
				
				$sqlcrit = $sqlcrit . "(l" . $cnc . " = '$catitem') AND ";
				
				$all_updates[$gcntr] = $sqlcrit . "(l" . ($cnc+1) . " = '')";
				
				$gcntr++;
				
				$cnc++;
				}
	
	}


### UPDATE CATEGORY NUMBERS (MAKE NUMBERS LESS FROM THE CATEGORIES WHERE LINKS ARE MOVED OUT)

foreach $item (@all_updates)
	{
	$sql = "UPDATE dirs SET linknrs = linknrs - 1 WHERE $item";
	
	#print $sql . "<BR><BR>";

	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
	}



foreach $ditem (@all_links)
	{
	$sql_str2 = $sql_str2 . " (lnkid = '$ditem') OR";
	}
	$sql_str2 = substr($sql_str2, 0, length($sql_str2) -2);


$sql = "DELETE FROM links WHERE $sql_str2";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}



######################

}




sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

